﻿using System.ComponentModel.Composition;
using System.Linq;
using Seesmic.Sdp.Extensibility;

namespace DoodleGrouper
{
    /// <summary>
    /// A Timeline Item Processor that will take incoming timeline items and move them into the correct group timelines.
    /// </summary>
    [Export(typeof (ITimelineItemProcessor))]
    public class GroupProcessor : ITimelineItemProcessor
    {
        public void Deliver(TimelineItemContainer timelineItemContainer)
        {
            foreach (UserList userList in Plugin.UserLists)
            {
                if (userList.Users.Contains(timelineItemContainer.TimelineItem.Username))
                {
                    userList.GroupTimeline.Add(timelineItemContainer);
                }
            }
        }

        public bool Filter(TimelineItemContainer timelineItemContainer)
        {
            return true;
            // If the user has been saved against a user list, return true.
            // Apparently if I return false, the item doesn't appear here at all, not even in home.
            // Useful if you want to remove an item altogether I guess.
            return Plugin.UserLists.Any(userList => userList.Users.Contains(timelineItemContainer.TimelineItem.Username));
        }

        public void Process(TimelineItemContainer timelineItemContainer)
        {
        }

        public void Remove(TimelineItemContainer timelineItemContainer)
        {
        }
    }
}