﻿using System.Collections.Generic;
using System.Windows;
using Seesmic.Sdp.Extensibility;

namespace DoodleGrouper
{
    public class UserListGroup : ISidebarActionGroup
    {
        private string _persistId = "UserListGroup";
        private bool _pressed;
        private IList<ISidebarAction> _sidebarActions;

        public bool CanInvoke
        {
            get { return true; }
        }

        public IList<ISidebarAction> SidebarActions
        {
            get
            {
                prepareSidebar();

                return _sidebarActions;
            }
        }

        public void Invoke(SidebarActionContext context)
        {
            if (_pressed)
            {
                _pressed = false;
            }
            else
            {
                _pressed = true;

                prepareSidebar();
            }
        }

        public string PersistId
        {
            get { return _persistId; }
        }

        public DataTemplate Icon
        {
            get { return (DataTemplate)Plugin.Resources["RemoveFromGroupPath"]; }
        }

        public string Text
        {
            get { return "User Groups"; }
        }

        public bool IsHighlighted
        {
            get { return _pressed; }
        }

        private void prepareSidebar()
        {
            if (null == _sidebarActions)
            {
                _sidebarActions = new List<ISidebarAction>();
            }
        }
    }
}