﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using DoodleGrouper.ViewModel;
using Seesmic.Sdp.Extensibility;

namespace DoodleGrouper.View
{
    public partial class ModifyGroupControl : UserControl
    {
        public event ButtonCancelHandler ButtonCancel;

        public delegate void ButtonCancelHandler(object sender, EventArgs e);

        public event ButtonAcceptHandler ButtonAccept;

        public delegate void ButtonAcceptHandler(object sender, EventArgs e);

        public ModifyGroupControl()
        {
            InitializeComponent();
        }

        private void addButton_Click(object sender, RoutedEventArgs e)
        {
            UserList group = getUserList();

            if (!group.Users.Contains(AddUser.Text))
            {
                group.Users.Add(AddUser.Text);
                group.Users.Sort(u => u);
            }

            AddUser.Text = string.Empty;
        }

        private void okButton_Click(object sender, RoutedEventArgs e)
        {
            ButtonAccept(this, new EventArgs());
        }

        private void cancelButton_Click(object sender, RoutedEventArgs e)
        {
            var columnView = this.Parent as IColumnView;

            ButtonCancel(this, new EventArgs());
        }

        private UserList getUserList()
        {
            var model = DataContext as ViewModelModifyGroup;

            UserList group = null;

            if (model != null)
            {
                group = Plugin.UserLists.Where(u => u.Name == model.GroupName).Single();
            }

            return group;
        }
    }
}
